	opt o+,ow-,a+

	include bios.s

; NOTE: be sure to save the menubar area, it will be destroyed
;       also, allocate at least a 1K stack before calling do_show()

; needs macros for:
;	setexc
;	fgetdta
;	fsetdta
;	fopen
;	fclose
;	cursconf

;
; IS_SHOW_AVAILABLE - call once to determine if DC Desktop is installed
;                     a future version of DC SHOWIT (DC SHOWER) will emulate the
;                     DC Desktop trap #9 stuff, so this _will_ be available
;                     to people who don't have DC Desktop
;
; returns d0 = 0 on success
;         d0 = -1 on failure
;
is_show_available:
    Setexc	#$29,#-1			; Setexc call to return vector $a4 (TRAP 9)
    move.l  d0,a0				; current vector in trap #9
    cmp.w   #$dc,-(a0)  		; is DC DESKTOP present? magic word?
    bne.s   .no_go       		; nope

	dc.w	$a000				; line a
	move.l	a0,linea_ptr		; this is definitely needed
	move.w	-42(a0),max_y		; programs like flash change the max y

	moveq	#0,d0
	rts
.no_go
	moveq	#-1,d0
	rts

;
; SETUP_SHOW - setup various things before calling SHOW stuff
;
; call every time, user might have run a SHOW
; module from the desktop and installed it in
; the chain, thus you could get a different address
;
; NOTE: LINEA stuff may not be applicable to your situation
;
setup_show:	
	move.l	linea_ptr,a0		; in Flash! bottom line is short 1
	move.w	-42(a0),old_max_y	; save current value
	move.w	max_y,-42(a0)		; restore real value

	Fgetdta				; get old dta
	move.l	d0,old_dta	; save it
	Fsetdta	#my_dta		; set up temp dta

    pea		dummy       ; fake routine, you can push any long address
    move.w	#$dc00,-(a7); function $dc00 in DC DESKTOP, register new SHOW
    trap	#9          ; do it
						; don't fixup stack just yet

    move.l	d0,old_show	; save current show vector

    move.l	d0,2(a7)    ; restore the vector we just got
    trap	#9          ; do it
    addq	#6,a7       ; fix stack

	dc.w	$a00a		; hide mouse
	Cursconf	#1,#0	; show cursor
	rts

;
; DO_SHOW - actually call the SHOW routines
;
; NOTE: our protocol needs the file to be opened
; d0 = file handle
; a0 = pointer to the FULL filename
;
; returns
; d0 = 0 on success
; d0 = non-zero (should be file handle) on failure - no one showed it
;
do_show:

;	move.w	handle,d0		; DC Show protocol - file handle in d0
;	lea		filename,a0		; DC Show protocol - filename in a0

	move.l	old_show,a1		; jsr thru DC Show vector
	jsr		(a1)
	tst.l	d0				; did anyone get it? if someone uses the
							; file, they return 0, else non-zero
							; usually (should be) the file handle
	beq.s	.rts			; yep

	move.l	old_show,a1		; nope, try DC SHOW HEX - views anything
	moveq	#0,d0			; clear d0, in case garbaged
	move.w	handle,d0		; file handle in d0
	lea		filename,a0		; filename in a0
	move.l	#'_HEX',-(a7)	; DC SHOWHEX magic cookie on stack
	jsr		(a1)			; jsr thru DC Show vector
	addq	#4,sp			; fixup stack
.rts
	rts

;
; SETDOWN_SHOW - cleanup after show
;
setdown_show:
	Fclose	handle			; close file
	Cursconf	#0,#0		; hide cursor
	dc.w	$a009			; show mouse
	Fsetdta	old_dta			; restore old dta
	move.l	linea_ptr,a0	; obviuos
	move.w	old_max_y,-42(a0)	; restore saved max_y
    rts

	BSS

dummy:
old_show:	ds.l	1
linea_ptr:	ds.l	1
old_dta:	ds.l	1
handle:		ds.w	1
max_y:		ds.w	1 
old_max_y:	ds.w	1
filename:	ds.b	120
my_dta:		ds.b	44
